Bullet = {}

-- CONSTRUCTOR
function Bullet:new(style, x, y, xd, yd)
    local object = {
		style = style,
		x = x,
		y = y,
		xd = xd,
		yd = yd,
		state = "alive",
		currentFrame = 1,
		frameTick = 0,
		tick1 = 0,
		tick2 = 0
    }


	------------------------------------------------------- BULLET TYPES

	if style == 1 then
		object.hitX = 6; object.hitY = 6; object.hitW = 2; object.hitH = 2; object.type = 1
		object.animation = {IMG_bullet2, IMG_bullet3}
	end

	if style == 2 then
		object.hitX = 5; object.hitY = 5; object.hitW = 5; object.hitH = 5; object.type = 2
		object.animation = {IMG_bullet4, IMG_bullet5}
	end

	if style == 3 then
		object.hitX = 5; object.hitY = 5; object.hitW = 11; object.hitH = 5; object.type = 3
		object.animation = {IMG_bullet6, IMG_bullet7}
	end

	if style == 4 then
		object.hitX = 5; object.hitY = 5; object.hitW = 3; object.hitH = 3; object.type = 4
		object.animation = {IMG_bullet8, IMG_bullet9}
	end

	if style == 5 then
		object.hitX = 6; object.hitY = 6; object.hitW = 4; object.hitH = 4; object.type = 5
		object.animation = {IMG_bullet10, IMG_bullet11}
	end

   if style == 6 then
		object.hitX = 5; object.hitY = 5; object.hitW = 2; object.hitH = 4; object.type = 6
		object.animation = {IMG_bullet12, IMG_bullet13}
	end



    setmetatable(object, { __index = Bullet })
    return object
end


function Bullet:update(dt)

	-- ANIMATE

	self.frameTick = self.frameTick + dt
	if self.frameTick > 0.025 then
		if self.currentFrame == 1 then
			self.currentFrame = 2
		elseif self.currentFrame == 2 then
			self.currentFrame = 1
		end
		self.frameTick = 0
	end

	-- MOVE
	self.x = self.x + self.xd*dt
	self.y = self.y + self.yd*dt

	---------------------------------------------------- SPECIFIC BULLET BEHAVIORS
	if self.type == 4 then
		if self.y > 90 then
			self.yd = self.yd - (30*dt)
		end
	end

	if self.type == 5 then
		if self.y > 60 then
			self.yd = self.yd - (5*dt)
		end
		self.tick1 = self.tick1 + dt
		if self.tick1 > 1.2 and self.tick2 == 0 then
			self.tick2 = 1
			SND_enemy6:seek(0); SND_enemy6:play()
			b = Bullet:new(5, self.x, self.y, -40, 60); table.insert(ebullets, b)
			b = Bullet:new(5, self.x, self.y, 40, 60); table.insert(ebullets, b)
		end
	end

   if self.type == 6 then
		if self.y > 20 then
			if self.x < p.x then
            self.x = self.x + (math.random(1, 50)*dt)
         end
         if self.x > p.x then
            self.x = self.x - (math.random(1, 50)*dt)
         end
		end
	end


	-- MARK FOR DEATH IF BELOW SCREEN
	if self.y > 200 then self.state = "dead" end

	-- MARK FOR DEATH IF ABOVE SCREEN
	if self.y < -100 then self.state = "dead" end

end


function Bullet:draw()
	if self.state == "alive" then
		g.draw(self.animation[self.currentFrame], self.x*scale, self.y*scale, 0, crtscale, crtscale)
	end

	-- HITBOXES
	if showHitBoxes then
		g.setColor(255, 0, 0, hitBoxAlpha)
		g.rectangle("fill", (self.x+self.hitX)*scale, (self.y+self.hitY)*scale, self.hitW*scale, self.hitH*scale)
		g.setColor(255, 255, 255, 255) -- SET COLOR BACK
	end
end
