Player = {}

-- CONSTRUCTOR
function Player:new()
    local object = {
		x = 147,
		y = 162,
		hitX = 7,
		hitY = 8,
		hitW = 12,
		hitH = 5,
		deathTick = 0,
		flickTick = 0,
		flickSwitch = 0,
		speed = 90,
		image = IMG_player1,
		lives = 3,
		continues = 0,
		state = "alive",
		level = 1,
		bullets = {},
		xd = 0,
		showing = true,
		canfire = true
    }
    setmetatable(object, { __index = Player })

	-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
	totalobjects = totalobjects + 1

    return object
end

function Player:fire()
	if self.canfire then

			if self.level == 1 then
				if table.getn(self.bullets) < 2 then
					SND_bullet:seek(0)
					SND_bullet:play()
					local bullet = {
						x = self.x+6,
						y = self.y-4,
						hitX = 5,
						hitY = 5,
						hitW = 4,
						hitH = 4,
						alive = true,
						speed = 190
				}
				table.insert(self.bullets, bullet)
				-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
				totalobjects = totalobjects + 1
				end
			end

			if self.level == 2 then
				if table.getn(self.bullets) < 3 then
					SND_bullet:seek(0)
					SND_bullet:play()
					local bullet = {
					x = self.x+6,
					y = self.y-4,
					hitX = 5,
					hitY = 5,
					hitW = 4,
					hitH = 4,
					alive = true,
					speed = 220
				}
				table.insert(self.bullets, bullet)
				-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
				totalobjects = totalobjects + 1
				end
			end

			if self.level == 3 then
				if table.getn(self.bullets) < 7 then
					SND_bullet:seek(0)
					SND_bullet:play()
					local bullet = {
					x = self.x+3,
					y = self.y-3,
					hitX = 5,
					hitY = 5,
					hitW = 4,
					hitH = 4,
					alive = true,
					speed = 320
				}
				table.insert(self.bullets, bullet)
				local bullet = {
					x = self.x+9,
					y = self.y-3,
					hitX = 5,
					hitY = 5,
					hitW = 4,
					hitH = 4,
					alive = true,
					speed = 320
				}
				table.insert(self.bullets, bullet)
				-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
				totalobjects = totalobjects + 2
			end
        end
	end
end


function Player:update(dt)

	-- MOVE PLAYER
	self.x = self.x + self.xd
	self.xd = 0
	if self.x > 307 then p.x = 307 end
	if self.x < -13 then p.x = -13 end

	-- CHECK LEVEL AND XP
	if xp > 1000 then
		if self.level < 3 then
			self.level = self.level + 1
			SND_levelup:seek(0)
			SND_levelup:play()
			if self.level < 3 then xp = 0 end
			if self.state == "alive" then
				if self.level == 1 then
					self.image = IMG_player1
					local playerflash = anim:new(-100, -100, 16, 0.07, {IMG_player4, IMG_player5}, true)
					table.insert(animations, playerflash)
				end
				if self.level == 2 then
					self.image = IMG_player2
					local playerflash = anim:new(-100, -100, 16, 0.07, {IMG_player4, IMG_player5}, true)
					table.insert(animations, playerflash)
				end
				if self.level == 3 then
					self.image = IMG_player3
					local playerflash = anim:new(-100, -100, 16, 0.07, {IMG_player6, IMG_player7}, true)
					table.insert(animations, playerflash)
				end
			end
			local ding = anim:new(278, 0, 10, 0.1, {IMG_xp11, IMG_xp12})
			table.insert(animations, ding)
		end
	end

	-- MOVE BULLETS
	for i=1, table.getn(self.bullets), 1 do
		self.bullets[i].y = self.bullets[i].y - self.bullets[i].speed*dt
		if self.bullets[i].y < -10 then
			self.bullets[i].alive = false
		end
	end

	-- REMOVE DEAD BULLETS
	for i=1, table.getn(self.bullets), 1 do
		if self.bullets[i] then
			if self.bullets[i].alive == false then
				table.remove(self.bullets, i)

				-- REMOVE TO TOTAL OBJECTS DEBUG VARIABLE
				totalobjects = totalobjects - 1
			end
		end
	end

	-- DEATH TIMER
	if self.lives == 0 then
		self.state = "dead"
	end
	if self.state == "dying" then
		self.deathTick = self.deathTick + dt
		if self.deathTick > 1.4 then
			self.flickTick = self.flickTick + dt
			if level.asteroids == false then
				self.canfire = true
			end
		else
			self.canfire = false
		end

		if self.flickTick > 0.075 then
			self.flickTick = 0
			if self.flickSwitch == 0 then
				self.flickSwitch = 1
				self.showing = true
			elseif self.flickSwitch == 1 then
				self.flickSwitch = 0
				self.showing = false
			end
		end
		if self.deathTick > 5 then
			if self.lives > 0 then
				self.deathTick = 0
				self.state = "alive"
				self.showing = true
				self.flickTick = 0
				self.flickSwitch = 0
			else
				self.deathTick = 0
				self.state = "dead"
				self.flickTick = 0
				self.flickSwitch = 0
			end
		end

	end

end


function Player:draw()
	if self.showing then g.draw(self.image, self.x*scale, self.y*scale, 0, crtscale, crtscale) end
	-- DRAW BULLETS
	for i=1, table.getn(self.bullets), 1 do
		g.draw(IMG_bullet1, self.bullets[i].x*scale, self.bullets[i].y*scale, 0, crtscale, crtscale, 0, 0)
	end
end

function Player:kill()
	if self.state == "alive" then
		SND_pdeath:seek(0)
		SND_pdeath:play()
		self.state = "dying"
		self.lives = self.lives - 1
		self.level = 1
		if level.asteroids then
			self.image = IMG_player8
		else
			self.image = IMG_player1
		end
		xp = 0
		self.showing = false
		local poof = explosion:new(self.x, self.y)
		table.insert(explosions, poof)

		-- GAMEOVER
		if self.lives == 0 then
			controlEnabled = false
			level.music:stop()
			flushEnemies()
			--[[local gameover = anim:new(85, 73, 30, 0.1, {IMG_gameover1, IMG_gameover2, IMG_gameover3})
			table.insert(animations, gameover)]]--

			gameoverTimer = timer:new({
				{0, 1, "local gameover = anim:new(85, 73, 30, 0.1, {IMG_gameover1, IMG_gameover2, IMG_gameover3}); table.insert(animations, gameover)"},
				{5, 1, ""},
				{0, 1, "resetToMainScreen()"}
			})
			table.insert(timers, gameoverTimer)

			SND_gameover:seek(0)
			SND_gameover:play()
		end

	end
end

function Player:reset()
	self.lives = 3
	self.state = "alive"
	self.showing = true
	self.level = 1
	self.image = IMG_player1
	self.deathTick = 0
	self.flickTick = 0
	self.flickSwitch = 0
	xp = 0
	self.canfire = true
end

function Player:resetLives(asteroidstage)
	if asteroidstage then
		-- Do Nothing
	else
		a = anim:new(0, 0, 10, 0.1, {IMG_life5, IMG_life4})
	end
	table.insert(animations, a)
	self.lives = 3
end

function Player:resetPosition()
	self.x = 147
end
