anim = {}

-- CONSTRUCTOR
function anim:new(x, y, loops, speed, images, maptoplayer)
    local object = {
		x = x,
		y = y,
		loops = loops,
		images = images,
		running = true,
		speed = speed,
		tick1 = 0,
		currentFrame = 1
    }
	if maptoplayer then
		object.maptoplayer = true
	end
	object.frames = table.getn(images)
    setmetatable(object, { __index = anim })
	-- ADD TO TOTALOBJECTS DEBUG VARIABLE
	totalobjects = totalobjects + 1
    return object
end


function anim:update(dt)

	if self.running then

		self.tick1 = self.tick1 + dt
		if self.tick1 > self.speed then
			if self.currentFrame < self.frames then
				self.currentFrame = self.currentFrame + 1
				self.tick1 = 0
			elseif self.currentFrame == self.frames and self.loops > 0 then
				self.currentFrame = 1
				self.tick1 = 0
				self.loops = self.loops - 1
			elseif self.currentFrame == self.frames and self.loops == 0 then
				self.running = false
			end
		end

		if self.maptoplayer then
			self.x = p.x
			self.y = p.y
			if p.state ~= "alive" then
				self.running = false
			end
		end

	end
end


function anim:draw()
	if self.running then
		love.graphics.draw(self.images[self.currentFrame], self.x*scale, self.y*scale, 0, crtscale, crtscale)
	end
end
