-------------------------------------------------------------------- VARIABLES
controlEnabled = false
control_start_isdown = false
control_a_isdown = false
keycontrol_start_isdown = false
keycontrol_a_isdown = false
antiControlDoubling = false



function checkControls(dt)

	local controlPress = controlPress
   local gamepads = love.joystick.getJoysticks()

	---------------------------------------------------------------- GAMEPAD 1 CONTROL
   if gamepads[1] then

      -- BUTTONS
      if gamepads[1]:isGamepadDown("a") then
         if control_a_isdown == false then
            control_a_isdown = true
            controlPress("a", dt)
         end
      else
         if control_a_isdown then
            control_a_isdown = false
         end
      end

   	if gamepads[1]:isGamepadDown("b") then
   		controlPress("b", dt)
   	end

   	if gamepads[1]:isGamepadDown("start") then
   		if control_start_isdown == false then
   			control_start_isdown = true
   			controlPress("start", dt)
   		end
   	else
   		if control_start_isdown then
   			control_start_isdown = false
   		end
   	end

      -- AXES
      if antiControlDoubling == false then
      	if gamepads[1]:getGamepadAxis("leftx") > 0.3 then
      		controlPress("right", dt)
      	end

      	if gamepads[1]:getGamepadAxis("leftx") < -0.3 then
      		controlPress("left", dt)
      	end

      	if gamepads[1]:getGamepadAxis("lefty") > 0.3 then
      		controlPress("down", dt)
      	end

      	if gamepads[1]:getGamepadAxis("lefty") < -0.3 then
      		controlPress("up", dt)
      	end
      end

      -- HATS
      if antiControlDoubling == false then
         if gamepads[1]:isGamepadDown("dpleft") then
            controlPress("left", dt)
         end

         if gamepads[1]:isGamepadDown("dpright") then
            controlPress("right", dt)
         end

         if gamepads[1]:isGamepadDown("dpup") then
            controlPress("up", dt)
         end

         if gamepads[1]:isGamepadDown("dpdown") then
            controlPress("down", dt)
         end
      end

		-- DEBUG TEMP
		if debugButtons then
			if gamepads[1]:getGamepadAxis("rightx") > 0.3 then
				level.frame = level.frame + 1
			end
		end

   end




	------------------------------------------------------- KEYBOARD CONTROL

	-- QUIT GAME ON ESCAPE KEY
	if love.keyboard.isDown("escape") then
		controlPress("start", dt)
	end

   -- DIRECTIONAL
   if antiControlDoubling == false then
   	if love.keyboard.isDown("right") then
   		controlPress("right", dt)
   	end

   	if love.keyboard.isDown("left") then
   		controlPress("left", dt)
   	end

   	if love.keyboard.isDown("up") then
   		controlPress("up", dt)
   	end

   	if love.keyboard.isDown("down") then
   		controlPress("down", dt)
   	end
   end

	if love.keyboard.isDown("space") then
		if keycontrol_a_isdown == false then
			keycontrol_a_isdown = true
			controlPress("a", dt)
		end
	else
		if keycontrol_a_isdown then
			keycontrol_a_isdown = false
		end
	end

	if love.keyboard.isDown("z") then
		controlPress("b", dt)
	end

	if love.keyboard.isDown("x") then
		controlPress("y", dt)
	end

   -- RESTET antiControlDoubling
   antiControlDoubling = false
end






-------------------------------------------------------------------------------------- CONTROL FUNCTIONAILTY
function controlPress(control, dt)

	if control == "left" then
      antiControlDoubling = true
		if gamestate == "game" then
         p.xd = p.xd - (p.speed*dt)
      end
	end

	if control == "right" then
      antiControlDoubling = true
		if gamestate == "game" then
         p.xd = p.xd + (p.speed*dt)
      end
	end

	if control == "up" then
      antiControlDoubling = true
		if gamestate == "paused" then
			if pause_current == 2 then pause_current = 1; SND_blip:seek(0); SND_blip:play() end
		end
		if gamestate == "title" then
			if prompt == 2 then prompt = 1; SND_blip:seek(0); SND_blip:play(); titleScreenPrompt.alpha = 1 end
		end
	end

	if control == "down" then
      antiControlDoubling = true
	 	if gamestate == "paused" then
	  		if pause_current == 1 then pause_current = 2; SND_blip:seek(0); SND_blip:play() end
		end
		if gamestate == "title" then
			if prompt == 1 then prompt = 2; SND_blip:seek(0); SND_blip:play(); titleScreenPrompt.alpha = 1 end
		end
	end

	if control == "a" then
		if gamestate == "game" then p:fire() end
		if gamestate == "title" then
			if prompt == 1 then
				SND_theme:stop()
				SND_select:play()
				initGame()
			end
			if prompt == 2 then
				love.filesystem.write("starseekerSave.lua", "highScore = " .. highScore)
				love.event.quit();
			end
		end
		if gamestate == "paused" then
			if pause_current == 1 then
				gamestate = "game"
				SND_select:seek(0); SND_select:play()
				level.music:play()
			end
			if pause_current == 2 then
				SND_select:seek(0); SND_select:play()
				resetToMainScreen()
			end
		end
	end

	if control == "start" then
		if gamestate == "game" then
			gamestate = "paused"
			pause_current = 1
			level.music:pause()
			SND_beep:seek(0)
			SND_beep:play()
		end
	end

	if control == "b" then
		if debugButtons then
			if showHitBoxes == false then
				showHitBoxes = true
			else
				showHitBoxes = false
			end
		end
	end

	if control == "y" then
		if debugButtons then
			p:reset()
			level.init()
		end
	end

end
