explosion = {}

-- CONSTRUCTOR
function explosion:new(x, y, r, g, b)
	 local rn = math.random
    local object = {
    	x = x-6,
    	y = y-6,
		r = r,
		g = g,
		b = b,
    	life = 0,
    	state = "alive",
		stars = {}
    }

    for i=1, 60, 1 do
	    local star = {
	    	x = x,
	    	y = y,
			currentlife = 0,
			life = rn()+rn(0,2),
	    	xd = rn(-66,66),
	    	yd = rn(-66, 66),
			alpha = 1
		}
		table.insert(object.stars, star)
	end

	-- ADD TO TOTAL OBJECTS DEBUG VARIABLE
	totalobjects = totalobjects + 51

    setmetatable(object, { __index = explosion })
    return object
end


function explosion:update(dt)
	local rn = math.random
	for i=1, table.getn(self.stars), 1 do
		self.stars[i].x = self.stars[i].x + self.stars[i].xd*dt
		self.stars[i].y = self.stars[i].y + self.stars[i].yd*dt
		self.stars[i].alpha = self.stars[i].alpha - (rn()-0.48)
	end
	-- REMOVE DEAD STARS
	for i=1, table.getn(self.stars), 1 do
		if self.stars[i] then
			if self.stars[i].alpha <= 0 then table.remove(self.stars, i) end
		end
	end
end


function explosion:draw()
	for i=1, table.getn(self.stars), 1 do
		g.setColor(1, 1, 1, self.stars[i].alpha)
		g.draw(IMG_star1, self.stars[i].x*scale, self.stars[i].y*scale, 0, crtscale, crtscale)
		g.setColor(1, 1, 1, 1)
	end
end
