-- VARS
level = {}
level.tick = 0
level.cluster1 = 0
level.cluster2 = 0
level.cluster3 = 0
level.cluster4 = 0
level.cluster5 = 0
level.frame = 0
level.frameSpeed = 1
level.running = false
level.asteroids = false
level.asteroidsObjects = false
level.asteroidTick = 0
level.startinglevel = 1
level.currentlevel = level.startinglevel
level.levelObjects = false
level.asteroidsSpeed = 0
level.music = SND_song1

function level.updateMusic()
	if level.currentlevel == 1 then
		level.music = SND_song1
	elseif level.currentlevel == 2 then
		level.music = SND_song2
	elseif level.currentlevel == 3 then
		level.music = SND_song3
	elseif level.currentlevel == 4 then
		level.music = SND_song4
	elseif level.currentlevel == 5 then
		level.music = SND_song5
	end
end

function level.init()
	level.running = true
	asteroids = false
	level.frame = 0
	starSpeedMin = 20
	starSpeedMax = 130
	p.speed = 90
	level.frameSpeed = 1
	level.tick = 0
	level.cluster1 = 0
	level.cluster2 = 0
	level.cluster3 = 0
	level.cluster4 = 0
	level.cluster5 = 0
	level.levelObjects = false
end

function level.script1(levelimg)
	if level.frame == 2 then
		a = anim:new(90, 70, 5, 0.3, {levelimg, levelimg, IMG_blank}); table.insert(animations, a)
		level.music:play()
		level.frame = level.frame + 1; p:resetLives()
	end
	if level.frame == 5 then
		level.levelObjects = true
		level.frame = level.frame + 1
	end
end

function level.script2(astspeed)
	-- FLUSH
	if level.frame == 200 then
		level.frameSpeed = 1
		level.levelObjects = false
		flushEnemies()
		level.frame = level.frame + 1
		level.music:stop()
		level.music = SND_silence
	end

	-- ASTEROID DODGE
	if level.frame == 210 then
		level.levelObjects = false
		a = anim:new(65, 54, 25, 0.12, {IMG_asteroids1, IMG_asteroids1, IMG_asteroids2}); table.insert(animations, a)

		--love.audio.rewind(SND_asteroid)
		level.music = SND_asteroid; level.music:play()
		p:resetLives(true)
		starSpeedMin = 190
		starSpeedMax = 260
		p.speed = 160
		p.image = IMG_player8
		p.canfire = false
		level.asteroidsSpeed = astspeed
		level.asteroids = true
		level.frameSpeed = 1
		level.frame = level.frame + 1
	end
	if level.frame == 218 then
		level.asteroidsObjects = true
		level.frame = level.frame + 1
	end

	-- CLEAN UP
	if level.frame == 255 then
		--level.asteroids = false
		level.asteroidsObjects = false
		-- p:reset()
		level.music:stop()
		level.music = SND_silence
		level.frame = level.frame + 1
	end
	if level.frame == 270 then
		level.asteroids = false
		level.asteroidsObjects = false
		level.currentlevel = level.currentlevel + 1
		level.updateMusic()
		level.init()
		p:reset()
	end
end


function level.update(dt)
	local enemies = enemies
	local rn = math.random
	if level.running and p.state == "alive" then

		-- ASTEROID DODGE
		if level.asteroidsObjects then
			level.asteroidTick = level.asteroidTick + dt
			if level.asteroidTick > (0.3 - (level.currentlevel / 40)) then
				level.asteroidTick = 0
				local enemy = Enemy:new("asteroid"..tostring(rn(1,4)), rn(-10, 310));
				enemies[#enemies+1] = enemy
			end
		end


		-- ADVANCE LEVEL FRAME
		level.tick = level.tick + dt*level.frameSpeed
		level.frameSpeed = level.frameSpeed + 0.0004
		if level.tick > 0.7 then level.frame = level.frame + 1; level.tick = 0 end






		------------------------------------------------------------------------------------------------------------------- LEVEL 1

		if level.currentlevel == 1 then
			level.script1(IMG_level1)
			-- enemy SCRIPT
			if level.levelObjects then

				-- CLUSTER 1
				level.cluster1 = level.cluster1 + dt
				if level.cluster1 > 2 then level.cluster1 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(1, randomx); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 2
				level.cluster2 = level.cluster2 + dt
				if level.cluster2 > 3 then level.cluster2 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(1, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+15); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+30); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 3
				level.cluster3 = level.cluster3 + dt
				if level.cluster3 > 4.2 then level.cluster3 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(2, randomx); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 4 (enemy TESTING)
				level.cluster4 = level.cluster4 + dt
				if level.cluster4 > 5 then level.cluster4 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(10, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(10, randomx-100, -200); enemies[#enemies+1] = enemy
				end

			end
			level.script2(0)
		end






		------------------------------------------------------------------------------------------------------------------- LEVEL 2

		if level.currentlevel == 2 then
			level.script1(IMG_level2)
			-- enemy SCRIPT
			if level.levelObjects then

				-- CLUSTER 1
				level.cluster1 = level.cluster1 + dt
				if level.cluster1 > 4 then level.cluster1 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(1, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+20); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+60); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 2
				level.cluster2 = level.cluster2 + dt
				if level.cluster2 > 35 then level.cluster2 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(2, randomx); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 3
				level.cluster3 = level.cluster3 + dt
				if level.cluster3 > 4 then level.cluster3 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(3, randomx); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 4
				level.cluster4 = level.cluster4 + dt
				if level.cluster4 > 22 then level.cluster4 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(4, 30); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(4, 280); enemies[#enemies+1] = enemy
				end

			end
			level.script2(30)
		end






		------------------------------------------------------------------------------------------------------------------- LEVEL 3

		if level.currentlevel == 3 then
			level.script1(IMG_level3)
			-- enemy SCRIPT
			if level.levelObjects then

				-- CLUSTER 1
				level.cluster1 = level.cluster1 + dt
				if level.cluster1 > 5 then level.cluster1 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(8, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+120); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 2
				level.cluster2 = level.cluster2 + dt
				if level.cluster2 > 10 then level.cluster2 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(2, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(2, randomx+60); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 3
				level.cluster3 = level.cluster3 + dt
				if level.cluster3 > 9 then level.cluster3 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(3, randomx); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 4
				level.cluster4 = level.cluster4 + dt
				if level.cluster4 > 17 then level.cluster4 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(4, 30); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(4, 280); enemies[#enemies+1] = enemy
				end

			end
			level.script2(60)
		end






		------------------------------------------------------------------------------------------------------------------- LEVEL 4

		if level.currentlevel == 4 then
			level.script1(IMG_level4)
			-- enemy SCRIPT
			if level.levelObjects then

				-- CLUSTER 1
				level.cluster1 = level.cluster1 + dt
				if level.cluster1 > 4 then level.cluster1 = 0; local randomx = rn(-10, 310)
					if rn(1, 2) == 1 then
						local enemy = Enemy:new(9, 40); enemies[#enemies+1] = enemy
					else
						local enemy = Enemy:new(9, 260); enemies[#enemies+1] = enemy
					end
				end

				-- CLUSTER 2
				level.cluster2 = level.cluster2 + dt
				if level.cluster2 > 7 then level.cluster2 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(1, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+40); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx+80); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 3
				level.cluster3 = level.cluster3 + dt
				if level.cluster3 > 9 then level.cluster3 = 0; local randomx = rn(-10, 310)
					-- HOLDER
				end

				-- CLUSTER 4
				level.cluster4 = level.cluster4 + dt
				if level.cluster4 > 17 then level.cluster4 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(4, 30); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(4, 280); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(4, 60, -100); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(4, 250, -100); enemies[#enemies+1] = enemy
				end

			end
			level.script2(90)
		end






		------------------------------------------------------------------------------------------------------------------- LEVEL 5

		if level.currentlevel == 5 then
			level.script1(IMG_level5)
			-- enemy SCRIPT
			if level.levelObjects then

				-- CLUSTER 1
				level.cluster1 = level.cluster1 + dt
				if level.cluster1 > 4 then level.cluster1 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(6, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -20); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -40); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -60); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -80); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -100); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 2
				level.cluster2 = level.cluster2 + dt
				if level.cluster2 > 7 then level.cluster2 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(6, randomx); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -20); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -40); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -60); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -80); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(6, randomx, -100); enemies[#enemies+1] = enemy
					local enemy = Enemy:new(1, randomx, -120); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 3
				level.cluster3 = level.cluster3 + dt
				if level.cluster3 > 9 then level.cluster3 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(2, randomx, -120); enemies[#enemies+1] = enemy
					local randomx = rn(-10, 310)
					local enemy = Enemy:new(7, randomx); enemies[#enemies+1] = enemy
				end

				-- CLUSTER 4
				level.cluster4 = level.cluster4 + dt
				if level.cluster4 > 17 then level.cluster4 = 0; local randomx = rn(-10, 310)
					local enemy = Enemy:new(7, randomx); enemies[#enemies+1] = enemy
				end

			end
			level.script2(130)
		end


		------------------------ ending
		if level.currentlevel == 6 then
			if level.frame == 1 then
				score = score + 500
				controlEnabled = false
				gamestate = "ending"
				starSpeedMin = 5
				starSpeedMax = 30
				a = anim:new(88, 70, 200, 0.13, {IMG_ending1, IMG_ending2}); table.insert(animations, a)
				level.frame = 2
			end
			if level.frame == 30 then
				resetToMainScreen()
			end
		end





	end
end
